(    .
  - .
  Copyright [C] 1992-1999 A.Cherezov ac@forth.org
    16-  32-  - 1995-96
   -  1999
)

VECT OK.
VECT <MAIN>
VECT ?LITERAL
VECT ?SLITERAL
USER-VALUE SOURCE-ID-XT \    ,   
VECT PROCESS-ERR ( ior -- ior ) \    ().

: DEPTH ( -- +n ) \ 94
\ +n -   ,     
\      +n.
  SP@ S0 @ - NEGATE 4 U/
;
: ?STACK ( -> ) \   " ",     
  SP@ S0 @ SWAP U< IF S0 @ SP! -4 THROW THEN
;
: ?COMP ( -> )
  STATE @ 0= IF -312 THROW THEN (     )
;

: WORD ( char "<chars>ccc<char>" -- c-addr ) \ 94
\   .  , 
\  char.
\   ,    
\      .
\ c-addr -   ,   
\     .
\        ,
\     .
\     ,     .
\      .
  DUP PSKIP PARSE
  DUP HERE C! HERE 1+ SWAP CMOVE
  BL HERE COUNT + !
  HERE
;

: ' ( "<spaces>name" -- xt ) \ 94
\   .  name,  .  name 
\   xt,    name.   , 
\  name  .
\     ' name EXECUTE    name.
  PARSE-WORD SFIND 0=
  IF -321 THROW THEN (  -? )
;

: CHAR ( "<spaces>name" -- char ) \ 94
\   .  ,  .
\       .
  PARSE-WORD DROP C@ ;

: INTERPRET_ ( -> ) \   
  SAVEERR? ON
  BEGIN
    PARSE-WORD DUP
  WHILE
    SFIND ?DUP
    IF
         STATE @ =
         IF COMPILE, ELSE EXECUTE THEN
    ELSE
         S" NOTFOUND" SFIND 
         IF EXECUTE
         ELSE 2DROP ?SLITERAL THEN
\          ?SLITERAL
    THEN
    ?STACK
  REPEAT 2DROP
;

VARIABLE &INTERPRET
' INTERPRET_ &INTERPRET !

: INTERPRET &INTERPRET @ EXECUTE ;

: HALT ( ERRNUM -> ) \    
  >R exit ;

\ : BYE ( -- ) \ 94 TOOLS EXT
\    ,   .
\  0 HALT ;

: .SN ( n --)
\  n   
   >R BEGIN
         R@
      WHILE
        SP@ R@ 1- CELLS + @ DUP 0< 
        IF DUP U>D <# #S #> TYPE
           ." (" ABS 0 <# #S [CHAR] - HOLD #> TYPE ." ) " ELSE . THEN
        R> 1- >R
      REPEAT RDROP
;

: OK1
  STATE @ 0=
  IF ."  Ok" DEPTH 70 UMIN 
     0 ?DO [CHAR] . EMIT LOOP CR 
  THEN
;

: EVAL-WORD ( a u -- )
\  ( )     a u
    SFIND ?DUP    IF
    STATE @ =  IF 
    COMPILE,   ELSE 
    EXECUTE    THEN
                  ELSE
    -2003 THROW THEN
;

: [   \ 94 CORE
\ :  .
\ :   ,  .
\ : ( -- )
\   . [   .
  STATE 0!
; IMMEDIATE

: ] ( -- ) \ 94 CORE
\   .
  TRUE STATE !
;

: QUIT ( -- ) ( R: i*x ) \ CORE 94
\   ,    SOURCE-ID.
\       .
\   .  :
\ -        ,  >IN
\    .
\ -      , 
\       ,   ,
\      .

\ R0 @ RP! (   ,   "['] QUIT CATCH" )
  CONSOLE-HANDLES
  0 TO SOURCE-ID
  [COMPILE] [
  <MAIN>
;

: MAIN1 ( -- )
  BEGIN REFILL
  WHILE INTERPRET OK.
  REPEAT BYE
;
' MAIN1 TO <MAIN>

: SAVE-SOURCE ( -- i*x i )
  SOURCE-ID-XT  SOURCE-ID   >IN @   SOURCE   CURSTR @   6
;

: RESTORE-SOURCE ( i*x i  -- )
  6 <> IF ABORT THEN
  CURSTR !    SOURCE!  >IN !  TO SOURCE-ID   TO SOURCE-ID-XT
;

: EVALUATE ( i*x c-addr u -- j*x ) \ 94
\     .
\  -1  SOURCE-ID.  ,  c-addr u,
\     ,  >IN  0
\  .      - 
\    .
\       EVALUATE .
  SOURCE-ID >R TIB >R #TIB @ >R >IN @ >R
  -1 TO SOURCE-ID
  #TIB ! TO TIB >IN 0!
    ['] INTERPRET CATCH
  R> >IN ! R> #TIB ! R> TO TIB R> TO SOURCE-ID
  THROW
;

: RECEIVE-WITH-XT  ( i*x source source-xt xt -- j*x ior )
\    
\     source,      source-xt
\  xt
\    
  SAVE-SOURCE N>R
  C/L 2+ ALLOCATE THROW DUP >R  0 SOURCE!  CURSTR 0!
  SWAP TO SOURCE-ID-XT
  SWAP TO SOURCE-ID
  CATCH  DUP IF PROCESS-ERR ( err -- err ) THEN
  R> FREE THROW
  NR> RESTORE-SOURCE
;

: RECEIVE-WITH  ( i*x source xt -- j*x ior )
\    
\     source,  xt
\    
  0 SWAP RECEIVE-WITH-XT
;

: INCLUDE-FILE ( i*x fileid -- j*x ) \ 94 FILE
\  fileid  .     ,
\    SOURCE-ID.  fileid  SOURCE-ID.
\  ,  fileid,  .  0  BLK.
\        .
\    :    ,  
\    ,  >IN    .
\     ,    
\   .
\    ,     
\      .
\   ,  fileid ,  
\   -    fileid, 
\      .  
\   ,  (  ) 
\     .
  TIB >R >IN @ >R #TIB @ >R SOURCE-ID >R BLK @ >R CURSTR @ >R
  C/L 2 + ALLOCATE THROW TO TIB  BLK 0!
  TO SOURCE-ID
  CURSTR 0!
  BEGIN REFILL
  WHILE INTERPRET
  REPEAT
  TIB FREE THROW
  SOURCE-ID CLOSE-FILE THROW (    )
  R> CURSTR ! R> BLK ! R> TO SOURCE-ID R> #TIB ! R> >IN ! R> TO TIB
;

: INCLUDED_ ( i*x c-addr u -- j*x ) \ 94 FILE
\  c-addr u  .     ,
\    SOURCE-ID.  ,  c-addr u,
\   fileid  SOURCE-ID     .
\  0  BLK.
\        .
\    :    ,  
\    ,  >IN    .
\     ,    
\   .
\    ,     
\      .
\   ,  fileid ,  
\   -    fileid, 
\      .  
\   ,  (  ) 
\     .
  CURFILE @ >R
  DUP CELL+ ALLOCATE THROW CURFILE !
  2DUP CURFILE @ SWAP 1+ MOVE

\  R/O OPEN-FILE-SHARED ?DUP 
   R/O OPEN-FILE ?DUP 
  IF NIP CURFILE @ FREE DROP R> CURFILE ! THROW THEN (    )
  DUP >R
  ['] INCLUDE-FILE CATCH SAVEERR
  ?DUP IF R> CLOSE-FILE DROP THROW
          \       
       ELSE RDROP THEN

  CURFILE @ FREE THROW R> CURFILE !
;
: REQUIRED ( waddr wu laddr lu -- )
  2SWAP SFIND
  IF DROP 2DROP EXIT
  ELSE 2DROP INCLUDED_ EXIT THEN
;

: REQUIRE ( "word" "libpath" -- )
  PARSE-WORD PARSE-WORD 2DUP + 0 SWAP C!
  REQUIRED
;
