(      WORDLIST.
  - .
  Copyright [C] 1992-1999 A.Cherezov ac@forth.org
    16-  32-  - 1995-96
   -  1999
    ..
  email:mak@mail.rtc.neva.ru
  http://informer.rtc.neva.ru/
    {812}105-92-03
    {812}552-47-64
)
HEX
1 CONSTANT &IMMEDIATE \     IMMEDIATE
2 CONSTANT &VOC

\  wid -   ,    
\ ,  .      
\      .
: >BODY ( xt -- a-addr ) \ 94
\ a-addr -   ,  xt.
\   ,  xt   ,
\   CREATE.
(  1+ @    2.5 )
  5 +
;

: +SWORD ( addr u wid -> ) \   ҙ  ,
         \ v  addr u,  ۣߘ, ؘ wid.
         \ L۳ș ٿ ٚ   Ԛ 
         \  ؚ  ALLOT.
  HERE LAST !
  HERE 2SWAP S", SWAP DUP @ , !
;

: +WORD ( A1, A2 -> ) \     ,
         \     A1,  , 
         \  A2.       
         \    ALLOT.    
         \  A2     , 
         \      .
         \ : C" SP-FORTH" CONTEXT @ +WORD
  HERE LAST !
  HERE ROT ", SWAP DUP @ , !
;

: WORDLIST ( -- wid ) \ 94 SEARCH
\     ,    wid.
\          
\         .
\       8     
\     .
  HERE VOC-LIST  @ ,  VOC-LIST !
  HERE 0 , \        
       0 , \        
       0 , \ wid -
       0 , \   = wid ,   
;

: CLASS! ( cls wid -- ) CELL+ CELL+ CELL+ ! ;
: CLASS@ ( wid -- cls ) CELL+ CELL+ CELL+ @ ;
: PAR!   ( Pwid wid -- ) CELL+ CELL+ ! ;
: PAR@   ( wid -- Pwid ) CELL+ CELL+ @ ;

\ -5 -- cfa
\ -1 -- flags
\  0 -- NFA
\  1 -- name
\  n -- LFA

CODE NAME> ( NFA -> CFA )
     MOV EAX, -5 [EAX]
     RET
END-CODE

CODE NAME>C ( NFA -> 'CFA )
     LEA EAX, -5 [EAX]
     RET
END-CODE

CODE NAME>F ( NFA -> FFA )
     LEA EAX, -1 [EAX]
     RET
END-CODE

CODE NAME>L ( NFA -> LFA )
     MOVZX EBX, BYTE [EAX]
     LEA EAX, [EBX] [EAX]
     LEA EAX, 1 [EAX]
     RET
END-CODE

CODE CDR ( NFA1 -> NFA2 )
     OR EAX, EAX
     JZ SHORT @@1
      MOVZX EBX, BYTE [EAX]
      MOV EAX, 1 [EBX] [EAX]
@@1: RET
END-CODE

: ID. ( NFA[E] -> )
  COUNT TYPE
;

: ?IMMEDIATE ( NFA -> F )
  NAME>F C@ &IMMEDIATE AND
;

: ?VOC ( NFA -> F )
  NAME>F C@ &VOC AND
;
1 [IF]
: IMMEDIATE ( -- ) \ 94
\      .
\   ,   
\   .
  LAST @ NAME>F DUP C@ &IMMEDIATE OR SWAP C!
;
[THEN]
: VOC ( -- )
\      "".
  LAST @ NAME>F DUP C@ &VOC OR SWAP C!
;

\ ==============================================
\  -       


\ ==============================================
\  -       

: N_UMAX ( nfa nfa1 -- nfa|nfa1 )
 OVER DUP IF NAME> THEN
 OVER DUP IF NAME> THEN U< IF NIP EXIT THEN DROP ;

: WL_NEAR_NFA ( addr wid - addr nfa | addr 0 )
   @
   BEGIN 2DUP DUP IF NAME> THEN U<
   WHILE CDR
   REPEAT
;

0
[IF]

: NEAR_NFA ( addr - nfa addr | 0 addr )
   0 SWAP 
   VOC-LIST
    BEGIN  @ DUP
    WHILE    DUP >R CELL+ WL_NEAR_NFA SWAP >R N_UMAX R>  R>
    REPEAT   DROP
;

[ELSE]

: WL_NEAR_NFA_N ( addr nfa - addr nfa | addr 0 )
   BEGIN 2DUP DUP IF NAME> THEN U<
   WHILE CDR
   REPEAT
;

: WL_NEAR_NFA_M (  addr wid - nfa2 addr | 0 addr )
   0 -ROT
   CELL+ @
   BEGIN  DUP
   WHILE  WL_NEAR_NFA_N  \  nfa addr nfa1
       SWAP >R 
       DUP  >R  N_UMAX 
       R>  DUP  IF CDR THEN
       R>  SWAP
   REPEAT DROP
;

: NEAR_NFA ( addr - nfa addr | 0 addr )
   0 SWAP 
   VOC-LIST
   BEGIN  @ DUP
   WHILE  DUP  >R   WL_NEAR_NFA_M
   >R  N_UMAX  R>  R>
   REPEAT DROP
;

[THEN]

: WordByAddr  ( addr -- c-addr u )
\  ,     
   DUP         DP @ U> IF DROP S" <not in the image>" EXIT THEN
   NEAR_NFA DROP  DUP 0= IF DROP S" <not found>"        EXIT THEN
   COUNT
;

DECIMAL