(  ,     .
  - .
  Copyright [C] 1992-1999 A.Cherezov ac@forth.org
    16-  32-  - 1995-96
   -  1999
)

USER LAST-CFA
USER-VALUE LAST-NON

: SHEADER ( addr u -- )
  HERE 0 , ( cfa )
  DUP LAST-CFA !
  0 C,     ( flags )
  -ROT  WARNING @
  IF 2DUP GET-CURRENT SEARCH-WORDLIST
     IF DROP 2DUP TYPE ."  isn't unique" CR THEN
  THEN
  CURRENT @ +SWORD
  ALIGN
  HERE SWAP ! (  cfa )
;

: HEADER ( "name" -- )  PARSE-WORD SHEADER ;

: CREATED ( addr u -- )
\    c-addr u   ,  .
\      ,  
\  .     
\   name. CREATE       name.
\ name : ( -- a-addr )
\ a-addr -    name.   name 
\     DOES>.
  SHEADER
  HERE DOES>A ! (  DOES )
  ['] _CREATE-CODE COMPILE,
;

: CREATE ( "<spaces>name" -- ) \ 94
   PARSE-WORD CREATED
;

: (DOES1) \  ,     CREATE ()
  R> DOES>A @ CFL + -
  DOES>A @ 1+ ! ;

CODE (DOES2)
   LEA  EBP, -4 [EBP]
   MOV  [EBP], EAX
   MOV  EAX, 4 [ESP]
   MOV  EBX, [ESP]
   LEA  ESP, 8 [ESP]
   JMP  EBX
END-CODE

: DOES>  \ 94
\ :  .
\ : ( C: clon-sys1 -- colon-sys2 )
\    ,  ,  
\ .       
\       DOES>,   .
\  colon-sys1   colon-sys2.  
\ ,  ,   .
\  : ( -- ) ( R: nest-sys1 -- )
\      name,  
\  name,  .     -
\ ,  nest-sys1.   ,  name
\     CREATE    ,
\  CREATE.
\ : ( i*x -- i*x a-addr ) ( R: -- nest-sys2 )
\      nest-sys2  
\ .     name  .  
\ i*x   name.
\ name : ( i*x -- j*x )
\   ,     ,
\  DOES>,   name.   i*x  j*x
\      name, .
  ['] (DOES1) COMPILE,
  ['] (DOES2) COMPILE,  \   ['] C-R>    MACRO, 
; IMMEDIATE

: VOCABULARY ( "<spaces>name" -- )
\      name.  name   
\        name.
  WORDLIST DUP
  CREATE
  ,
  LATEST OVER CELL+ ! (     )
  GET-CURRENT SWAP PAR! ( - )
\  FORTH-WORDLIST SWAP CLASS! (  )
  VOC
  ( DOES>     )
  (DOES1) (DOES2) \    DOES>,  
  @ CONTEXT !
;

: VARIABLE ( "<spaces>name" -- ) \ 94
\   .  name,  .
\    name   ,  .
\        .
\ name   "".
\ name : ( -- a-addr )
\ a-addr -   .     
\ 
  CREATE
  0 ,
;
: CONSTANT ( x "<spaces>name" -- ) \ 94
\   .  name,  .
\    name   ,  .
\ name   "".
\ name : ( -- x )
\  x  .
  HEADER
  ['] _CONSTANT-CODE COMPILE, ,
;
: VALUE ( x "<spaces>name" -- ) \ 94 CORE EXT
\   .  name,  .  
\   name   ,  ,   
\   x.
\ name   "".
\ : ( -- x )
\  x  .  x - ,   ,   ,
\     x TO name,    x, 
\   name.
  HEADER
  ['] _CONSTANT-CODE COMPILE, ,
  ['] _TOVALUE-CODE COMPILE,
;
: VECT ( -> )
  (  ,     ,
        xt  TO)
  HEADER
  ['] _VECT-CODE COMPILE, ['] NOOP ,
  ['] _TOVALUE-CODE COMPILE,
;

: ->VARIABLE ( x "<spaces>name" -- ) \ 94
  HEADER
  ['] _CREATE-CODE COMPILE,
  ,
;

: USER-ALIGNED ( -- a-addr n )
   USER-HERE 3 + 2 RSHIFT ( 4 / ) 4 * DUP
   USER-HERE -
;

: USER-CREATE ( "<spaces>name" -- )
  HEADER
  HERE DOES>A ! (  DOES )
  ['] _USER-CODE COMPILE,
  USER-ALIGNED
  USER-ALLOT  ,
;
: USER ( "<spaces>name" -- ) \   
  USER-CREATE
  4 USER-ALLOT
;

: USER-VALUE ( "<spaces>name" -- ) \ 94 CORE EXT
  HEADER
  ['] _USER-VALUE-CODE COMPILE,
  USER-ALIGNED SWAP ,
  CELL+ USER-ALLOT
  ['] _TOUSER-VALUE-CODE COMPILE,
;

: ->VECT ( x -> )
  HEADER
  ['] _VECT-CODE COMPILE, ,
  ['] _TOVALUE-CODE COMPILE,
;

: : ( C: "<spaces>name" -- colon-sys ) \ 94
\   .  ,  .
\    ,  "  ".
\       , 
\ colon-sys.   ,  ,  
\ .     , -
\    .     
\       ,    .
\ : ( i*x -- i*x ) ( R: -- nest-sys )
\   nest-sys   .  
\ i*x   .
\  : ( i*x -- j*x )
\   .   i*x  j*x 
\     .
  HEADER ]
  HIDE
  HERE TO :-SET
;

\ S" +mak\CompIF.f" INCLUDED

